<template>
  <div class="select-container">
    <label :for="id" :class="{label: true, 'label--floated': isLabelFloated, 'label--colored': isFocused}">{{ label }}</label>
    <select ref="select" :value="value.title" :class="{select: true, dark: dark}" :id="id" @focus="onFocus" @blur="onBlur" @input="onInput">
      <option :id="-1" v-if="!noEmpty"></option>
      <option v-for="(option, i) in options" :key="i" :id="option.id">{{ option.title }}</option>
    </select>
    <ArrowIcon :class="{arrow: true, dark: dark}"/>
  </div>
</template>

<script>
import TextField from "@/components/base/TextField";
import ArrowIcon from "@/assets/svgs/arrow_down.svg";

export default {
  name: "Select",
  components: {
    TextField,
    ArrowIcon
  },
  data() {
    return {
      isFocused: false
    }
  },
  props: {
    value: {
      type: Object,
      default: undefined
    },
    label: {
      type: String,
      default: ""
    },
    id: {
      type: String,
      required: true
    },
    dark: {
      type: Boolean,
      default: false
    },
    options: {
      type: Array,
      default: []
    },
    noEmpty: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    onFocus() {
      this.isFocused = true;
    },
    onBlur() {
      this.isFocused = false;
    },
    onInput() {
      this.$emit('input', { title: this.$refs.select.value, id: Number(this.$refs.select.options[this.$refs.select.selectedIndex].id) });
    }
  },
  computed: {
    isLabelFloated() {
      return this.isFocused || this.value.title ? true : false;
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.select-container
  position relative

.arrow
  position absolute
  left 2.5rem
  top 50%
  transform translateY(-50%)
  fill rgba($white, .75)
  &.dark
    fill rgba($black, .75)

.select
  /* for Firefox */
  -moz-appearance none
  /* for Chrome */
  -webkit-appearance none
  /* for IE */
  &::-ms-expand
    display none
  width 100%
  height 5.8rem
  border-radius 4px 4px 0 0
  padding: 2.2rem 1.6rem .5rem;
  font-family inherit 
  font-size $font-size
  border none
  outline none
  cursor pointer
  border-bottom 1px solid rgba($white, .4)
  color $white
  background-color rgba(#DCDCDC, .01)
  direction rtl
  & option
    background-color $black
  &:hover
    background-color rgba(#DCDCDC, .05)
    border-bottom 1px solid rgba($white, .8)
  &:focus
    background-color rgba(#DCDCDC, .1)
    border-bottom 1px solid rgba($primary, 1)
  &.dark
    border-bottom 1px solid rgba($black, .15)
    color $black
    background-color rgba(#DCDCDC, .2)
    & option
      background-color $white
    &:hover
      background-color rgba(#DCDCDC, .35)
      border-bottom 1px solid rgba($black, .2)
    &:focus
      background-color rgba(#DCDCDC, .5)

.label
  position absolute
  transition transform 150ms cubic-bezier(0.4, 0, 0.2, 1),color 150ms cubic-bezier(0.4, 0, 0.2, 1);
  transform-origin right top
  right 1.6rem
  top 1.6rem
  font-size $font-soze
  font-weight 300
  cursor pointer
  &--floated
    transform scale(.7) translateY(-70%)
    font-weight 400
    &.dense
      transform scale(.7) translateY(-50%)
  &--colored 
    color $primary
  &--error
    color $error
  &.dense
    font-size 1.4rem
    top .9rem
</style>